import kraken.entrytypes.MetaData as MetaData
import kraken.tools.TextUi as TextUi

def description(system, runtime):
    return """
    Regenerates the metadata cache of the kraken.
    It is recommended to run this command after manual editing of files,
    reconfigurations or crashes.
    Periodic running is also recommended.
    """

def execute(system, runtime):
   commands = [ 
      "Regenerate the metadata cache",
      "Rewrite all RDF entries"      
   ]
   commandname = TextUi.inputMenu("Select the command to execute:", commands)
   if commandname == "Regenerate the metadata cache":
       metadata = MetaData.generateCache(system, runtime)    
       return
   if commandname == "Rewrite all RDF entries":
       metadata = MetaData.generateCache(system, runtime, rewrite=1)
       return


