import kraken.tools.TextUi as TextUi
from Filters import *
from Sorters import *
from Query import *
from Classifiers import *
from Limiter import *
import GenerateQuerySet
import kraken.Constants
import os.path
import os
import pickle


def createSorterWithVerify(system, metadata):
   sorter = None
   while 1:
       if sorter == None:
           sorter = createSorter(system)
       if sorter != None:
           md = sorter.processMetaData(metadata)
       print "The created sorter is: " + str(sorter) + "\n"
       menuitems = [
          "Accept this sorter",
          "Save sorter to file",
          "List the entries sorted by this sorter", 
          "Create a different sorter",
       ]
       choice = TextUi.inputMenu("Enter your choice", menuitems)
       if choice == "Accept this sorter":
           return sorter
       if choice == "List the entries sorted by this sorter":
           for entry in md.entries:
              print entry.getProperty("Title")
       if choice == "Create a different sorter":
           sorter = None
       if choice == "Save sorter to file":
           sorterName = TextUi.inputString("Enter sorter name:")
           sorterFile = os.path.join(system.getProperty("filterDir"), 
              sorterName  + kraken.Constants.EXTENSION_SORTER)
           FILE = open(sorterFile, "w")
           pickle.dump(sorter, FILE)
           FILE.close()
           print "Sorter saved to " + sorterFile
        

def createSorter(system):
    menuitems = ["No sorting",
                 "Limit length",
                 "Reverse sorting", 
                 "Property based sorting", 
                 "Preferred value sorting",
                 "Multilevel sorting",
                 "Load sorting"
                 ]
    choice = TextUi.inputMenu("Enter your choice", menuitems)
    if choice == "No sorting":
        return NoSorting()
    if choice == "Property based sorting":
        sorting = EvaluationSorter()
        # FIXME: property lists
        sorting.propertyName = TextUi.inputString("Sort by property")
        sorting.ignoreCase = TextUi.confirm("Ignore case?")
        return sorting
    if choice == "Reverse sorting":
        sorting = ReverseSorting()
        print "Now, create the sorter which is reversed!!!\n"
        sorting.theSorter = createSorter()
        return sorting
    if choice == "Load sorting":
       lst = os.listdir(system.getProperty("filterDir"))
       sorters = []
       for a in lst: 
           if a[-4:] == kraken.Constants.EXTENSION_SORTER:
               sorters.append(a[0:-4])
       if len(lst) == 0:
           print "There are no saved sortings"
           return
       choice = TextUi.inputMenu("Choose the sorting to load", filters)
       sorterFile = os.path.join(system.getProperty("filterDir"), 
            choice + kraken.Constants.EXTENSION_SORTER)
       FILE = open(sorterFile)            
       sorting = pickle.load(FILE)
       FILE.close()
       return sorting
        
    print choice + " not supported yet!!! - returning No Sorting"
    return NoSorting()
        
        
